/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.mappers.PlanarSlice;

import java.awt.BorderLayout;
import javax.swing.JPanel;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import static org.visnow.vn.lib.basic.mappers.PlanarSlice.PlanarSliceShared.*;
import org.visnow.vn.lib.gui.ComponentBasedUI.ComponentFeature;
import static org.visnow.vn.lib.utils.probeInterfaces.ProbeDisplay.Position.*;

public class GUI extends javax.swing.JPanel
{

    private Parameters parameters;
    
    private ComponentFeature isoFeature;

    /**
     * Creates new form EmptyVisnowModuleGUI
     */
    public GUI()
    {
        initComponents();
        isolinePanel.setVisible(false);
        isolinesBox.setVisible(false);
    }
    
    void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup3 = new javax.swing.ButtonGroup();
        buttonGroup4 = new javax.swing.ButtonGroup();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));
        jPanel5 = new javax.swing.JPanel();
        sliceRemoveButton = new javax.swing.JButton();
        slicesClearButton = new javax.swing.JButton();
        addAreaButton = new javax.swing.JButton();
        refreshButton = new javax.swing.JButton();
        planeSlicesPanel = new javax.swing.JPanel();
        sliceBannersScaleSlider = new javax.swing.JSlider();
        positionCombo = new javax.swing.JComboBox<>();
        pointerLinesButton = new javax.swing.JRadioButton();
        sliceNumbersButton = new javax.swing.JRadioButton();
        jLabel1 = new javax.swing.JLabel();
        orderSlicesButton = new javax.swing.JButton();
        glyphControlPanel = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        geomProbeSelector = new javax.swing.JRadioButton();
        indexProbeSelector = new javax.swing.JRadioButton();
        geomProbePanel = new javax.swing.JPanel();
        indexProbePanel = new javax.swing.JPanel();
        slicesResolutionSlider = new javax.swing.JSlider();
        timeSlider = new org.visnow.vn.gui.widgets.FloatSlider();
        isolinePanel = new javax.swing.JPanel();
        isolinesComponentUI = new org.visnow.vn.lib.gui.ComponentBasedUI.ComponentFeatureUI();
        isolinesIntervalCombo = new org.visnow.vn.gui.widgets.IntervalCombo();
        jLabel4 = new javax.swing.JLabel();
        isolinesBox = new javax.swing.JCheckBox();
        jPanel3 = new javax.swing.JPanel();
        currentGraphTitleField = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        fontSizeSlider = new javax.swing.JSlider();

        setLayout(new java.awt.GridBagLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        add(filler1, gridBagConstraints);

        jPanel5.setLayout(new java.awt.GridBagLayout());

        sliceRemoveButton.setText("remove selected slice"); // NOI18N
        sliceRemoveButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                sliceRemoveButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel5.add(sliceRemoveButton, gridBagConstraints);

        slicesClearButton.setText("clear slices"); // NOI18N
        slicesClearButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                slicesClearButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel5.add(slicesClearButton, gridBagConstraints);

        addAreaButton.setText("add slice area"); // NOI18N
        addAreaButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                addAreaButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel5.add(addAreaButton, gridBagConstraints);

        refreshButton.setText("refresh"); // NOI18N
        refreshButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                refreshButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel5.add(refreshButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 1, 0);
        add(jPanel5, gridBagConstraints);

        planeSlicesPanel.setLayout(new java.awt.GridBagLayout());

        sliceBannersScaleSlider.setValue(20);
        sliceBannersScaleSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("slice banners scale"));
        sliceBannersScaleSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                sliceBannersScaleSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        planeSlicesPanel.add(sliceBannersScaleSlider, gridBagConstraints);

        positionCombo.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "at point", "top", "right", "bottom", "left" }));
        positionCombo.setSelectedIndex(2);
        positionCombo.addItemListener(new java.awt.event.ItemListener()
        {
            public void itemStateChanged(java.awt.event.ItemEvent evt)
            {
                positionComboItemStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 6, 0, 6);
        planeSlicesPanel.add(positionCombo, gridBagConstraints);

        buttonGroup3.add(pointerLinesButton);
        pointerLinesButton.setSelected(true);
        pointerLinesButton.setText("pointer lines"); // NOI18N
        pointerLinesButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                pointerLinesButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        planeSlicesPanel.add(pointerLinesButton, gridBagConstraints);

        buttonGroup3.add(sliceNumbersButton);
        sliceNumbersButton.setText("slice numbers"); // NOI18N
        sliceNumbersButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                sliceNumbersButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        planeSlicesPanel.add(sliceNumbersButton, gridBagConstraints);

        jLabel1.setText("planar slices position"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        planeSlicesPanel.add(jLabel1, gridBagConstraints);

        orderSlicesButton.setText("order slices"); // NOI18N
        orderSlicesButton.setMargin(new java.awt.Insets(2, 2, 2, 2));
        orderSlicesButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                orderSlicesButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 6, 0, 6);
        planeSlicesPanel.add(orderSlicesButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(planeSlicesPanel, gridBagConstraints);

        glyphControlPanel.setMaximumSize(new java.awt.Dimension(2147483647, 500));
        glyphControlPanel.setMinimumSize(new java.awt.Dimension(170, 460));
        glyphControlPanel.setOpaque(false);
        glyphControlPanel.setPreferredSize(new java.awt.Dimension(220, 500));
        glyphControlPanel.setRequestFocusEnabled(false);
        glyphControlPanel.setLayout(new java.awt.GridBagLayout());

        jPanel2.setLayout(new java.awt.GridLayout(1, 0));

        buttonGroup4.add(geomProbeSelector);
        geomProbeSelector.setSelected(true);
        geomProbeSelector.setText("geometric"); // NOI18N
        geomProbeSelector.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                geomProbeSelectorActionPerformed(evt);
            }
        });
        jPanel2.add(geomProbeSelector);

        buttonGroup4.add(indexProbeSelector);
        indexProbeSelector.setText("by index"); // NOI18N
        indexProbeSelector.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                indexProbeSelectorActionPerformed(evt);
            }
        });
        jPanel2.add(indexProbeSelector);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        glyphControlPanel.add(jPanel2, gridBagConstraints);

        geomProbePanel.setLayout(new java.awt.BorderLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        glyphControlPanel.add(geomProbePanel, gridBagConstraints);

        indexProbePanel.setLayout(new java.awt.BorderLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        glyphControlPanel.add(indexProbePanel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 0.1;
        add(glyphControlPanel, gridBagConstraints);

        slicesResolutionSlider.setMajorTickSpacing(100);
        slicesResolutionSlider.setMaximum(500);
        slicesResolutionSlider.setMinorTickSpacing(20);
        slicesResolutionSlider.setPaintLabels(true);
        slicesResolutionSlider.setPaintTicks(true);
        slicesResolutionSlider.setValue(200);
        slicesResolutionSlider.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "interpolated slices resolution", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 12))); // NOI18N
        slicesResolutionSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                slicesResolutionSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(slicesResolutionSlider, gridBagConstraints);

        timeSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("time"));
        timeSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                timeSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(timeSlider, gridBagConstraints);

        isolinePanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        isolinePanel.setLayout(new java.awt.GridBagLayout());

        isolinesComponentUI.setMinimumSize(new java.awt.Dimension(118, 50));
        isolinesComponentUI.setPreferredSize(new java.awt.Dimension(118, 51));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        isolinePanel.add(isolinesComponentUI, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        isolinePanel.add(isolinesIntervalCombo, gridBagConstraints);

        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel4.setText("Interval:"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.VERTICAL;
        gridBagConstraints.insets = new java.awt.Insets(4, 11, 4, 5);
        isolinePanel.add(jLabel4, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(isolinePanel, gridBagConstraints);

        isolinesBox.setText("draw isolines for a component"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        add(isolinesBox, gridBagConstraints);

        jPanel3.setLayout(new java.awt.GridBagLayout());

        currentGraphTitleField.setFont(new java.awt.Font("Dialog", 0, 14)); // NOI18N
        currentGraphTitleField.setBorder(javax.swing.BorderFactory.createTitledBorder("current slice title"));
        currentGraphTitleField.setMinimumSize(new java.awt.Dimension(10, 40));
        currentGraphTitleField.setPreferredSize(new java.awt.Dimension(10, 45));
        currentGraphTitleField.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                currentGraphTitleFieldActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel3.add(currentGraphTitleField, gridBagConstraints);

        jLabel5.setText("font size"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(0, 8, 0, 0);
        jPanel3.add(jLabel5, gridBagConstraints);

        fontSizeSlider.setFont(new java.awt.Font("Dialog", 0, 10)); // NOI18N
        fontSizeSlider.setMajorTickSpacing(5);
        fontSizeSlider.setMaximum(-30);
        fontSizeSlider.setMinimum(-70);
        fontSizeSlider.setPaintTicks(true);
        fontSizeSlider.setValue(-50);
        fontSizeSlider.setMinimumSize(new java.awt.Dimension(100, 30));
        fontSizeSlider.setPreferredSize(new java.awt.Dimension(200, 30));
        fontSizeSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                fontSizeSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(2, 15, 2, 0);
        jPanel3.add(fontSizeSlider, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(jPanel3, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    
    private void slicesClearButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_slicesClearButtonActionPerformed
    {//GEN-HEADEREND:event_slicesClearButtonActionPerformed
        parameters.set(CLEAR_SLICES, true);
    }//GEN-LAST:event_slicesClearButtonActionPerformed

    private void sliceBannersScaleSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_sliceBannersScaleSliderStateChanged
    {//GEN-HEADEREND:event_sliceBannersScaleSliderStateChanged
        parameters.set(SLICE_BANNERS_SCALE, .2f * (float)Math.pow(2, sliceBannersScaleSlider.getValue() / 20. - 1));
    }//GEN-LAST:event_sliceBannersScaleSliderStateChanged

    private void positionComboItemStateChanged(java.awt.event.ItemEvent evt)//GEN-FIRST:event_positionComboItemStateChanged
    {//GEN-HEADEREND:event_positionComboItemStateChanged
        switch (positionCombo.getSelectedIndex()) {
            case 0:
                parameters.set(SLICE_POSITION, AT_POINT);
                break;
            case 1:
                parameters.set(SLICE_POSITION, TOP);
                break;
            case 2:
                parameters.set(SLICE_POSITION, RIGHT);
                break;
            case 3:
                parameters.set(SLICE_POSITION, BOTTOM);
                break;
            case 4:
                parameters.set(SLICE_POSITION, LEFT);
                break;
        }
    }//GEN-LAST:event_positionComboItemStateChanged

    private void sliceRemoveButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_sliceRemoveButtonActionPerformed
    {//GEN-HEADEREND:event_sliceRemoveButtonActionPerformed
        parameters.set(DEL_SLICE, true);
    }//GEN-LAST:event_sliceRemoveButtonActionPerformed

    private void pointerLinesButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pointerLinesButtonActionPerformed
        parameters.set(POINTER_LINE, pointerLinesButton.isSelected());
    }//GEN-LAST:event_pointerLinesButtonActionPerformed

    private void sliceNumbersButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sliceNumbersButtonActionPerformed
        parameters.set(POINTER_LINE, pointerLinesButton.isSelected());
    }//GEN-LAST:event_sliceNumbersButtonActionPerformed

    private void orderSlicesButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_orderSlicesButtonActionPerformed
        parameters.set(ORDER_SLICES,true);
    }//GEN-LAST:event_orderSlicesButtonActionPerformed

    private void geomProbeSelectorActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_geomProbeSelectorActionPerformed
    {//GEN-HEADEREND:event_geomProbeSelectorActionPerformed
        parameters.set(TYPE, geomProbeSelector.isSelected() ? 
                                         PlanarSliceShared.ProbeType.GEOMETRIC : 
                                         PlanarSliceShared.ProbeType.INDEX);
        updateGlyphControlPanel();     
    }//GEN-LAST:event_geomProbeSelectorActionPerformed

    private void indexProbeSelectorActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_indexProbeSelectorActionPerformed
    {//GEN-HEADEREND:event_indexProbeSelectorActionPerformed
        parameters.set(TYPE, geomProbeSelector.isSelected() ? 
                                         PlanarSliceShared.ProbeType.GEOMETRIC : 
                                         PlanarSliceShared.ProbeType.INDEX);
        updateGlyphControlPanel();     
    }//GEN-LAST:event_indexProbeSelectorActionPerformed

    private void slicesResolutionSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_slicesResolutionSliderStateChanged
        if (!slicesResolutionSlider.getValueIsAdjusting()) 
            parameters.set(SLICE_RESOLUTION, Math.max(20, slicesResolutionSlider.getValue()));
    }//GEN-LAST:event_slicesResolutionSliderStateChanged

    private void timeSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_timeSliderStateChanged
        parameters.set(TIME, timeSlider.getVal());
    }//GEN-LAST:event_timeSliderStateChanged

    private void addAreaButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_addAreaButtonActionPerformed
    {//GEN-HEADEREND:event_addAreaButtonActionPerformed
        parameters.set(ADD_SLICE_AREA, true);
    }//GEN-LAST:event_addAreaButtonActionPerformed

    private void currentGraphTitleFieldActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_currentGraphTitleFieldActionPerformed
    {//GEN-HEADEREND:event_currentGraphTitleFieldActionPerformed
        parameters.set(SLICE_TITLE,currentGraphTitleField.getText());
    }//GEN-LAST:event_currentGraphTitleFieldActionPerformed

    private void fontSizeSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_fontSizeSliderStateChanged
    {//GEN-HEADEREND:event_fontSizeSliderStateChanged
        if (parameters != null && !fontSizeSlider.getValueIsAdjusting())
        {
            double f = fontSizeSlider.getValue() / 30.;
            parameters.set(TITLE_SIZE, (float)Math.pow(10, f));
        }
    }//GEN-LAST:event_fontSizeSliderStateChanged

    private void refreshButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_refreshButtonActionPerformed
    {//GEN-HEADEREND:event_refreshButtonActionPerformed
        parameters.set(REFRESH_SLICES, true);
    }//GEN-LAST:event_refreshButtonActionPerformed

    public void setProbePanels(JPanel geomPanel, JPanel indexPanel)
    {
        parameters.setActive(false);
        parameters.setParameterActive(false);
        geomProbePanel.removeAll();
        indexProbePanel.removeAll();
        indexProbeSelector.setEnabled(indexPanel != null);
        geomProbeSelector.setEnabled(geomPanel != null);
        if (indexPanel != null) 
            indexProbePanel.add(indexPanel, BorderLayout.CENTER);
        if (geomPanel != null) {
            geomProbePanel.add(geomPanel, BorderLayout.CENTER);
            geomProbeSelector.setSelected(true);
            parameters.set(TYPE, ProbeType.GEOMETRIC);
        }
        else {
            indexProbeSelector.setSelected(true);
            parameters.set(TYPE, ProbeType.INDEX);
        }
        updateGlyphControlPanel();
        parameters.setParameterActive(true);
        parameters.setActive(true);
    }
    
    private void updateGlyphControlPanel()
    {
        boolean geom = parameters.get(TYPE) == ProbeType.GEOMETRIC;
        geomProbePanel.setVisible(geom);
        indexProbePanel.setVisible(!geom);
    }

    public void enableRemoveGraph(boolean enable)
    {
        sliceRemoveButton.setEnabled(enable);
    }

    public void enableAddGraph(boolean enable)
    {
        addAreaButton.setEnabled(enable);
    }
    
    public void setComponentFeature(ComponentFeature isoFeature)
    {
//        this.isoFeature = isoFeature;
//        isoFeature.addChangeListener(new ChangeListener()
//        {
//            @Override
//            public void stateChanged(ChangeEvent e)
//            {
//                DataArraySchema sch = isoFeature.getComponentSchema();
//                if (sch != null)
//                    isolinesIntervalCombo.setRangeLength((float)(sch.getPreferredMaxValue() - sch.getPreferredMinValue()), 5);
//            }
//        });
//        isolinesComponentUI.setComponentFeature(isoFeature);
    }
    
    public void setTimeRange(float startTime, float endTime) 
    {
        if (startTime < endTime) {
            timeSlider.setEnabled(true);
            timeSlider.setMinMax(startTime, endTime);
        }
        else {
//            timeSlider.setMinMax(startTime - .5f, endTime + .5f);
            timeSlider.setEnabled(false);
        }
    }
    
    void updateGUI(ParameterProxy p, boolean resetFully, boolean setRunButtonPending)
    {
    }
    
    void updateGraphTitle(String title)
    {
        currentGraphTitleField.setText(title);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addAreaButton;
    private javax.swing.ButtonGroup buttonGroup3;
    private javax.swing.ButtonGroup buttonGroup4;
    private javax.swing.JTextField currentGraphTitleField;
    private javax.swing.Box.Filler filler1;
    private javax.swing.JSlider fontSizeSlider;
    private javax.swing.JPanel geomProbePanel;
    private javax.swing.JRadioButton geomProbeSelector;
    private javax.swing.JPanel glyphControlPanel;
    private javax.swing.JPanel indexProbePanel;
    private javax.swing.JRadioButton indexProbeSelector;
    private javax.swing.JPanel isolinePanel;
    private javax.swing.JCheckBox isolinesBox;
    private org.visnow.vn.lib.gui.ComponentBasedUI.ComponentFeatureUI isolinesComponentUI;
    private org.visnow.vn.gui.widgets.IntervalCombo isolinesIntervalCombo;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JButton orderSlicesButton;
    private javax.swing.JPanel planeSlicesPanel;
    private javax.swing.JRadioButton pointerLinesButton;
    private javax.swing.JComboBox<String> positionCombo;
    private javax.swing.JButton refreshButton;
    private javax.swing.JSlider sliceBannersScaleSlider;
    private javax.swing.JRadioButton sliceNumbersButton;
    private javax.swing.JButton sliceRemoveButton;
    private javax.swing.JButton slicesClearButton;
    private javax.swing.JSlider slicesResolutionSlider;
    private org.visnow.vn.gui.widgets.FloatSlider timeSlider;
    // End of variables declaration//GEN-END:variables

}
